---
title: RTCPeerConnection.onaddstream
slug: Web/API/RTCPeerConnection/onaddstream
tags:
  - Deprecated
  - Event Handler
  - MediaStream
  - Property
  - RTCPeerConnection
  - SDP
  - Streams
  - WebRTC
  - WebRTC API
  - onaddstream
  - rtc
---
<p>{{WebRTCSidebar}}{{deprecated_header}}</p>

<p>The <code><strong>RTCPeerConnection.onaddstream</strong></code> event handler is a property containing the code to execute when the {{event("addstream")}} event, of type {{domxref("MediaStreamEvent")}}, is received by this {{domxref("RTCPeerConnection")}}. Such an event is sent when a {{domxref("MediaStream")}} is added to this connection by the remote peer. The event is sent immediately after the call {{domxref("RTCPeerConnection.setRemoteDescription", "setRemoteDescription()")}} and doesn't wait for the result of the SDP negotiation.</p>

<div class="warning">
<p><strong>Important:</strong> This property has been <strong>removed</strong> from the specification; you should now use {{domxref("RTCPeerConnection.ontrack")}} to watch for {{event("track")}} events instead. It is included here in order to help you adapt existing code and understand existing samples, which may not be up-to-date yet.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtcPeerConnection</em>.onaddstream = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A function which handles {{event("addstream")}} events. These events, of type {{domxref("MediaStreamEvent")}}, are sent when streams are added to the connection by the remote peer. The first time an event occurs may be nearly immediately after the remote end of the connection is set using {{domxref("RTCPeerConnection.setRemoteDescription()")}}; it doesn't wait for a particular stream to be accepted or rejected using {{Glossary("SDP")}} negotiation.</p>

<h2 id="Example">Example</h2>

<p>This code, based on an older version of our <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a> sample, responds to {{event("addstream")}} events by setting the video source for a {{HTMLElement("video")}} element to the stream specified in the event, and then enabling a "hang up" button in the app's user interface.</p>

<pre class="brush: js">pc.onaddstream = function(event) {
  document.getElementById("received_video").srcObject = event.stream;
  document.getElementById("hangup-button").disabled = false;
};
</pre>

<p>You can also use {{domxref("EventTarget.addEventListener", "addEventListener()")}} to add a handler for <code>addstream</code> events to an {{domxref("RTCPeerConnection")}}.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="warning">
<p><strong>Important:</strong> This property has been <strong>removed</strong> from the specification; you should now use {{domxref("RTCPeerConnection.ontrack")}} to watch for {{event("track")}} events instead. It is included here in order to help you adapt existing code and understand existing samples, which may not be up-to-date yet.</p>
</div>

<p>{{Compat("api.RTCPeerConnection.onaddstream")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Use the newer {{event("track")}} event, its type {{domxref("RTCTrackEvent")}}, and the {{domxref("RTCPeerConnection.ontrack")}} event handler property instead of this.</li>
 <li>The {{event("addstream")}} event and its type, {{domxref("MediaStreamEvent")}}.</li>
</ul>
